#include "Matrice.cpp"

class MatriceJacobi : public Matrice
{
	private :
		int m_seuil;

	public :
	
		MatriceJacobi(int m, int n, int seuil) : Matrice(m,n)
		{
			m_seuil = seuil;	
		}

		~MatriceJacobi(){}

		double* getVoisins(int ligne, int colonne)
		{
			double* valeurs = new double[4];
			if (!indiceLigneValide(ligne) || !indiceColonneValide(colonne))
				return NULL;
			
			valeurs[0] = (ligne == 0) ? m_seuil : getValeur(ligne-1,colonne);
			valeurs[1] = (ligne == getNumLignes()) ? m_seuil : getValeur(ligne+1,colonne);	
			valeurs[2] = (colonne == 0) ? m_seuil : getValeur(ligne,colonne-1);
			valeurs[3] = (colonne == getNumColonnes()) ? m_seuil : getValeur(ligne,colonne+1);
			return valeurs;
		}

		bool epsilonAtteint(MatriceJacobi* matricePrecedente,double epsilon)
		{
			double sommeDesDifferences = 0;
			for (int i=0;i<getNumLignes();i++)
				for (int j=0;j<getNumColonnes();j++)
				{

					sommeDesDifferences += getAbs(matricePrecedente->getValeur(i,j) - m_matrice[i][j]);
				}
			return sommeDesDifferences < epsilon;
		}

		double getAbs(double valeur)
		{
			return (valeur >= 0) ? valeur : -valeur;
		}


};
