#define SIZE_OF_DOUBLE 8
#define NUM_LINS_MAT 20
#define NUM_COLS_MAT 20
#define SEUIL -1
#define EPSILON 0.01
#define MAX_ITERATIONS 10
#define NUM_VOISINS 4
#define TAILLE_TAMPON  (SIZE_OF_DOUBLE * NUM_VOISINS)
#define NUM_WORKERS 5

#include <stdio.h>
#include <pthread.h>
#include "../libc++/msglib.h"
#include "../libc++/getkey.cc"
#include "MatriceJacobi.cpp"

key_t key = getkey("66666666");

struct Message{
	double *val;
	int tag;
};
struct MsgRetour{
	double result;
	int source;
	int tag;
};

void *worker(void *workerNum){
	
	int workNum = (int)workerNum;
	Message msg;
	//msg.valeurs = (double*)malloc(TAILLE_TAMPON);
	Port p(key);
	MsgRetour resultat;
	while (true)
	{
		resultat.result = 0;

		p.Recoit(&msg,sizeof(msg));
		//Un tag plus grand que le dernier indice de la matrice
		//signifie que l'esclave est libre! Joie!
		if (msg.tag == NUM_LINS_MAT * NUM_COLS_MAT)
			break;

		resultat.result = (msg.val[0] + msg.val[1] + msg.val[2] + msg.val[3]) / 4;
		resultat.source = workNum;
		resultat.tag = msg.tag;

		p.Envoie(&resultat,sizeof(resultat));
	}
	pthread_exit(NULL);
}

int main( int argc, char *argv[] )
{
	pthread_t workers[NUM_WORKERS];
    for(int i=0;i<NUM_WORKERS;i++){
    	pthread_create(&workers[i],	NULL,worker,(void*)i);
	}
    Port p(key);
	Message msg;
	MsgRetour retour;

	double resultat = 0;	
	int iteration = 0;
	MatriceJacobi* matrice = new MatriceJacobi(NUM_LINS_MAT,NUM_COLS_MAT,SEUIL);
	MatriceJacobi* matriceResultat = new MatriceJacobi(NUM_LINS_MAT,NUM_COLS_MAT,SEUIL);
	matrice->afficherMatrice();
	cout << endl;
	do
	{
		int prochaineCellule = 0;
		int calculsRestants = matrice->getNumLignes() * matrice->getNumColonnes();
		iteration++;
		for (int i=1;i<NUM_WORKERS;i++)
		{
			if (calculsRestants > 0)
			{
				//Opration pr-envoi
				msg.val = matrice->getVoisins(prochaineCellule / matrice->getNumColonnes(),prochaineCellule % matrice->getNumColonnes());
				msg.tag = prochaineCellule;
				
				p.Envoie(&msg,sizeof(msg)); 
				
				//Opration post-envoi
				prochaineCellule++;
				calculsRestants--;				
			}
		}
		for (int i=0;i<matrice->getNumLignes() * matrice->getNumColonnes();i++)
		{
			p.Recoit(&retour,sizeof(MsgRetour));
			matriceResultat->setValeur(retour.tag/matrice->getNumColonnes(),retour.tag % matrice->getNumColonnes(), resultat);
			if ((calculsRestants > 0) )
			{
				//Opration pr-envoi
				msg.val = matrice->getVoisins(prochaineCellule / matrice->getNumColonnes(),prochaineCellule % matrice->getNumColonnes());
				msg.tag = prochaineCellule;
				
				p.Envoie(&msg,sizeof(msg)); 
												
				//Opration post-envoi
				prochaineCellule++;
				calculsRestants--;				
			}
		}

		MatriceJacobi* tempMatrice = matrice;
		matrice = matriceResultat;
		matriceResultat = tempMatrice;
		cout << "Iteration " << iteration << " : " << endl;
		matrice->afficherMatrice();
		cout << endl;
	}while ((!matrice->epsilonAtteint(matriceResultat,EPSILON)) && (iteration < MAX_ITERATIONS));
	cout << "CALCULS TERMINES EN " << iteration << " ITERATION(S) AVEC" << endl << "UN SEUIL DE " << SEUIL << " ET UN EPSILON DE " << EPSILON << "." << endl;
	if (iteration == MAX_ITERATIONS)
		cout << "Nombre d'iterations maximal atteint." << endl;
	msg.tag = NUM_LINS_MAT*NUM_COLS_MAT;
	for (int i=1; i < NUM_WORKERS; i++) {
		p.Envoie(&msg,sizeof(msg)); 
	}
	pthread_exit(NULL);
}
