#include <iostream>
#include <pthread.h>

enum etats {pense, afaim, mange};

etats etatPhilosophe[5] = {pense,pense,pense,pense,pense};
pthread_cond_t attente[5];
pthread_mutex_t semAttente[5];
pthread_mutex_t mutexBaguettes[5];

void tester (int noPhilosophe){
	if ((etatPhilosophe[(noPhilosophe+1) % 5] != mange) 
	and (etatPhilosophe[(noPhilosophe+4) % 5] != mange) 
	and (etatPhilosophe[noPhilosophe] = afaim)){
		etatPhilosophe[noPhilosophe] = mange;
		pthread_cond_signal(&attente[noPhilosophe]);
	}
}

void prendre(int noPhilosophe){
	etatPhilosophe[noPhilosophe] = afaim;
	tester(noPhilosophe);
	if(etatPhilosophe[noPhilosophe] != mange){
		pthread_cond_wait(&attente[noPhilosophe],&semAttente[noPhilosophe]);
	}
	printf("Philosophe %d mange",noPhilosophe);
}
    
void deposer (int noPhilosophe){
	etatPhilosophe[noPhilosophe] = pense;
	tester((noPhilosophe + 4) % 5);
	tester((noPhilosophe + 1) % 5);
	printf("Philosophe %d pense", noPhilosophe);
}

void *philosophe(void *index){
	int i = (int)index;
	int indexBaguette1 =0 ,indexBaguette2 =0;
	while(true){

		// le philosophe est en train de penser
		printf("philosophe %d pense",i);
		sleep(int(random()*2000)+1000);

		printf("philosophe %d a faim",i);
		// les philosophes pairs commence par prendre la baguette de droite

		indexBaguette1 = i;
		indexBaguette2 = ((i % 5) +1);
		if( i % 2 == 0){
			int temp = indexBaguette1;
			indexBaguette1 = indexBaguette2; 
			indexBaguette2 = temp;
		}

		// "attente" de la disponibilite des baguettes
		pthread_mutex_lock(&mutexBaguettes[indexBaguette1]);
		printf("baguette %d prise par le philosophe %d",indexBaguette1, i);
		pthread_mutex_lock(&mutexBaguettes[indexBaguette2]);
		printf("baguette %d prise par le philosophe %d",indexBaguette2, i);

		// le philosophe est en train de manger
		printf("philosophe %d commence a manger",i);
		sleep(int(random()*5000)+1000);
		printf("philosophe %d a fini de manger",i);

		// le philosophe relache les baguettes
		printf("baguette %d remise par le philosophe %d",indexBaguette1, i);
		pthread_mutex_unlock(&mutexBaguettes[indexBaguette1]);
		printf("baguette %d remise par le philosophe %d",indexBaguette2, i);
		pthread_mutex_unlock(&mutexBaguettes[indexBaguette2]);
	}
	pthread_exit(NULL);
}

int main(int argc, char** argv)
{
	pthread_t philosophes[5];
	for(int i=0;i<5;i++){
		pthread_mutex_init(&mutexBaguettes[i],NULL);
		pthread_create(&philosophes[i],NULL,philosophe,(void*)i);
	}
    pthread_exit(NULL);
}
