﻿using System;
using System.Threading;

class PhilosophesMon
{
    public enum etatEnum { Pense, Faim, Mange };

    private const int number = 5;
    public static etatEnum[] etat = new etatEnum[number];
    public static Semaphore[] attente = new Semaphore[number];
    public static bool[] attenteBool = new bool[number];
    private static Object lockPrendre;
    private static Object lockDeposer;
    private static Object lockTester;

    static void Main(string[] args)
    {
        lockPrendre = new Object();
        lockDeposer = new Object();
        lockTester = new Object();

        for (int i = 0; i < number; i++)
            etat[i] = etatEnum.Pense;

        for (int i = 0; i < number; i++)
        {
            attente[i] = new Semaphore(1, 99);
            attenteBool[i] = true;
            attente[i].WaitOne();
        }

        for (int i = 0; i < number; i++)
            new Thread(Philosophe).Start(i);
    }
    
    private static void Philosophe(object no)
    {
        Random r = new Random();
        while (true)
        {
            Thread.Sleep(r.Next(1000, 2000));
            Prendre((int)no);

            Thread.Sleep(r.Next(1000, 5000));
            Deposer((int)no);
        }
    }

    private static void Prendre(int no)
    {
        lock (lockPrendre)
        {
            Console.WriteLine("Le philosophe {0} a faim", no);
            etat[no] = etatEnum.Faim;
            Tester(no);
            if (etat[no] != etatEnum.Mange)
            {
                Console.WriteLine("Le philosophe {0} attend son tour", no);
                attente[no].WaitOne();
            }
        }
    }

    private static void Deposer(int no)
    {
        lock (lockDeposer)
        {
            Console.WriteLine("Le philosophe {0} pense", no);
            etat[no] = etatEnum.Pense;
            // Laisse ses baguettes aux deux voisins et retourne penser
            Tester((no + 4) % 5);
            Tester((no + 1) % 5);
        }
    }

    private static void Tester(int no)
    {
        // Si les deux voisins ne mangent pas et que le philosophe courant a faim
        if ((etat[(no + 1) % 5] != etatEnum.Mange) && (etat[(no + 4) % 5] != etatEnum.Mange) && (etat[no] == etatEnum.Faim))
        {
            Console.WriteLine("Le philosophe {0} commence à manger", no);
            etat[no] = etatEnum.Mange;
            {
                attente[no].Release();
            }
        }
    }
}
