﻿using System;
using System.Threading;

class PhilosophesSem
{
    private const int number = 5;
    public static Mutex[] baguettes = new Mutex[number];
 
    static void Main(string[] args)
    {
        // Initialisation des Mutex (Semaphores binaires)
        for (int i = 0; i < number; i++)
            baguettes[i] = new Mutex();

        // Pars le nombre de threads voulus
        for (int i = 0; i < number; i++)
            new Thread(Philosophe).Start(i);
    }

    private static void Philosophe(object no)
    {
        int baguette1 = 0, baguette2 = 0;
        Random r = new Random();
        while (true)
        {
            Console.WriteLine("Le philosophe {0} pense", no);
            Thread.Sleep(r.Next(1000, 2000));

            Console.WriteLine("Le philosophe {0} a faim", no);
            baguette1 = (int)no;
            baguette2 = ((int)no % (number - 1) == 0 && (int)no != 0) ? 0 : baguette1 + 1;

            baguettes[baguette1].WaitOne();
            baguettes[baguette2].WaitOne();

            Console.WriteLine("Le philosophe {0} commence à manger, baguettes {1} - {2}", no, baguette1, baguette2);
            Thread.Sleep(r.Next(1000, 5000));
            Console.WriteLine("Le philosophe {0} arrete de manger", no);

            baguettes[baguette1].ReleaseMutex();
            baguettes[baguette2].ReleaseMutex();
        }
    }
}
