/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package jacobi;

import net.jini.core.lease.Lease;
import net.jini.space.JavaSpace;

public class JacobiMaster {
    private static final int NUM_LINS_MAT = 10;
    private static final int NUM_COLS_MAT = 10;
    private static final int SEUIL = 0;
    private static final double EPSILON = 0.01;
    private static final int MAX_ITERATIONS = 600;

    public static void main(String[] args) {
        try {
            Lookup finder = new Lookup(JavaSpace.class);
            JavaSpace space = (JavaSpace) finder.getService();
 
            int iteration = 0;
            MatriceJacobi matrice = new MatriceJacobi(NUM_LINS_MAT,NUM_COLS_MAT,SEUIL);
            MatriceJacobi matriceResultat = new MatriceJacobi(NUM_LINS_MAT,NUM_COLS_MAT,SEUIL);
            matrice.afficherMatrice();
            System.out.println();
            do
            {
                iteration++;
                for (int i=0;i<matrice.getNumLignes();i++)
                    for (int j=0;j<matrice.getNumColonnes();j++)
                    {
                        CalculJacobi calculJacobi = matrice.getCalculJacobi(i,j);
                        //System.out.println(calculJacobi.toString());
                        space.write(calculJacobi, null, Lease.FOREVER);
                    }
                   
                
                for (int i=0;i<matrice.getNumLignes();i++)
                    for (int j=0;j<matrice.getNumColonnes();j++)
                    {     
                        //System.out.println("En attente de : " + ((Integer)(i*matrice.getNumColonnes() + j)));
                        ResultatJacobi filtreResultat = new ResultatJacobi();
                        //filtreResultat.id = i*matrice.getNumColonnes() + j;
                        ResultatJacobi resultat = (ResultatJacobi)space.take(filtreResultat, null, 60*60*1000);
                        //System.out.println("Resultat [" + resultat.ligne + "][" + resultat.colonne + "] : " + resultat.resultat);
                        matriceResultat.setValeur(resultat.ligne, resultat.colonne, resultat.resultat);
                    }
                
                MatriceJacobi tempMatrice = matrice;
                matrice = matriceResultat;
                matriceResultat = tempMatrice;
                System.out.println("Iteration " + iteration + " : ");
                matrice.afficherMatrice();
                System.out.println();
        }while ((!matrice.epsilonAtteint(matriceResultat,EPSILON)) && (iteration < MAX_ITERATIONS));
        System.out.println("CALCULS TERMINES EN " + iteration + " ITERATION(S) AVEC \n" + "UN SEUIL DE " + SEUIL + " ET UN EPSILON DE " + EPSILON + ".");
        if (iteration == MAX_ITERATIONS)
            System.out.println("Nombre d'iterations maximal atteint.");
            
        } catch (Exception ex) {
            ex.printStackTrace();
        } 
    }

}
