/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package philosophesmoniteur;


import java.util.concurrent.Semaphore;

/**
 *
 * @author Doum
 */
public class PhilosophesMoniteur {
    private static enum ETAT {
        pense,
        aFaim,
        mange
    }
    private ETAT[] etatsPhilosophes = {ETAT.pense,ETAT.pense,ETAT.pense,ETAT.pense,ETAT.pense};
    private Semaphore[] mutexPhilos =  new Semaphore[5];

    public PhilosophesMoniteur()
    {
        for (int i=0;i<5;i++)
            mutexPhilos[i] = new Semaphore(0);
    }
    
    public synchronized void tester(int idPhilosophe)
    {
        if ((etatsPhilosophes[(idPhilosophe+1)%5] != ETAT.mange) && (etatsPhilosophes[(idPhilosophe+4)%5] != ETAT.mange))
        {
            etatsPhilosophes[idPhilosophe] = ETAT.mange;
            try {
                this.notifyAll();
            } catch (Exception e) {
                
            }
        }    
    }
    
    public synchronized void prendre(int idPhilosophe)
    {
        try {
            etatsPhilosophes[idPhilosophe] = ETAT.aFaim;
            tester(idPhilosophe);
            while (etatsPhilosophes[idPhilosophe] != ETAT.mange)
                this.wait();
            System.out.println("Philosophe " + idPhilosophe + " mange");
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    
    public synchronized void deposer(int idPhilosophe)
    {
        etatsPhilosophes[idPhilosophe] = ETAT.pense;
        tester((idPhilosophe+4) % 5);
        tester((idPhilosophe+1) % 5);
        System.out.println("Philosophe " + idPhilosophe + " pense");           
    }
    
    public static void main(String[] args) {
        PhilosophesMoniteur moniteur = new PhilosophesMoniteur();
        new Philosophe(0, moniteur).start();
        new Philosophe(1, moniteur).start();
        new Philosophe(2, moniteur).start();
        new Philosophe(3, moniteur).start();
        new Philosophe(4, moniteur).start();
    }
            
   
}
