# 
# Classe representant une matrice jacobi
# Marc Michaud
 
require 'matrice'

class MatriceJacobi < Matrice
  def initialize (m,n,r,s,e)
    @epsilon =e
    @seuil=s
    super(m,n,r)
  end
  
  def getvoisins(m,n)
    valeur = []
    if ((m <@m) && (n < @n))
      valeur[0] = (m== 0) ? @seuil : @valeurs[m-1][n]
      valeur[1] = (m==@m-1) ? @seuil : @valeurs[m+1][n]
      valeur[2] = (n== 0) ? @seuil : @valeurs[m][n-1]
      valeur[3] = (n==@n-1) ? @seuil : @valeurs[m][n+1]
      return valeur
    end
    return -1
  end
  
  def epsilonatteint(prev)
    somme=0
    for i in 0..(@m-1)
      for j in 0..(@n-1)
        # puts prev.getvaleur(i, j)
        # puts getvaleur(i, j)
        somme += (prev.getvaleur(i, j)- getvaleur(i, j)).abs
      end
    end
    puts "somme : " + somme.to_s + " epsilon : " + @epsilon.to_s
    return somme < @epsilon
  end

  def afficher()
    format = "%.3f"
    puts " "
    for i in 0..(@n+1)
      print sprintf(format, @seuil)
      print " "
    end
    print "\n"
    for i in 0..(@m-1)
      print sprintf(format, @seuil)
      print " "
      for j in 0..(@n-1)
        #print @valeurs[i][j]
        #k = @valeurs[i][j]
        print sprintf(format, @valeurs[i][j])
        print " "
      end
      print sprintf(format, @seuil)
      print "\n"
    end
    for i in 0..(@n+1)
      print sprintf(format, @seuil)
      print " "
    end
    puts " "
    
  end
  
  def deep_clone  
    Marshal::load(Marshal.dump(self))  
  end    

end

#mat2 = MatriceJacobi.new(2, 2, 20, 1)
#mat = MatriceJacobi.new(2, 2, 20, 1)
#mat.epsilonatteint(mat2,10)