#!/usr/bin/ruby -d
# Implementation des philosophes a l'aide des semaphores
# Marc Michaud

require 'thread'

srand
$semaphores=[]
for i in 0..4
  $semaphores[i] = Mutex.new
end

def philosopher (x)
  print "Le philosophe " + x.to_s + " pense\n"
  sleep 1*rand()
  print "Le philosophe " + x.to_s + " a faim\n"
  indexBaguette1 = x
  indexBaguette2 = ((x + 1) % 5)
  if x % 2 == 0
    indexBaguette1,indexBaguette2 = indexBaguette2, indexBaguette1
  end
  # "attente" de la disponibilite des baguettes
  $semaphores[indexBaguette1].synchronize {
    print "baguette " + indexBaguette1.to_s + " prise par le philosophe " + x.to_s + "\n"
    $semaphores[indexBaguette2].synchronize {
      print "baguette " + indexBaguette2.to_s + " prise par le philosophe " + x.to_s + "\n"
      # le philosophe est en train de manger
      print "philosophe " + x.to_s + " commence a manger\n"
      sleep 2*rand()
      print "philosophe " + x.to_s + " a fini de manger\n"
      # le philosophe relache les baguettes
      print "baguette " + indexBaguette2.to_s + " remise par le philosophe " + x.to_s + "\n"
    }
    print "baguette " + indexBaguette1.to_s + " remise par le philosophe " + x.to_s + "\n"
  }
end

threads=[]
for i in 0..4
  threads[i]= Thread.new {philosopher(i)}  
end
for i in 0..4
  threads[i].join
end
